【题目】:数组中有一个数字出现的次数超过了数组长度的一半,找出这个数字。

例如长度为9的数组{1,2,3,2,2,2,5,4,2}中次数超过了数组长度的一半的数字为2,而长度为8的数组{1,2,3,2,2,2,5,4}则为非法输入。

【思路一】:先对数组进行排序,再遍历排序后的数组,统计每个数的次数,出现次数最大的数即为要找的数。

时间复杂度:O(nlgn)+ O(n)= O(nlgn);空间复杂度:O(1)。

【思路二】:先对数组进行排序,出现次数超过数组长度的一半的数必然是数组中间的那个数。

时间复杂度:O(nlgn)+ O(1)= O(nlgn);空间复杂度:O(1)。

【思路三】:使用Hash表。遍历数组中的每个数字,找到它在哈希表中对应的位置并增加它出现的次数。Hash表只适用于元素的范围(range)比较小的情况,而假设我们的数组是一个整型数组,取值范围跨度太大,所以不适合用哈希表,太浪费空间了。

时间复杂度:O(n);空间复杂度:O(range)。

【思路四】:既然该数字为数组的中位数,即长度为n的数组中第[n/2]大数字。那么有没有更快的方法求解?我们已经有成熟的O(n)算法求解数组的第K大数字,即Kmin。那么可以借鉴其思想。

时间复杂度:O(n);空间复杂度:O(1)。

缺点是由于使用了QuickSort的Partition算法,需要交换数组中数字顺序,会修改输入数组。

具体代码如下:

 C++ Code 
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72
73
74
75
76
77
78
79
80
81
82
83
84
85
86
87
88
89
90
91
92
93
94
95
96
97
98
99
100
101
102
103
104
105
106
107
108
109
110
111
112
113
114
115
116
117
118
119
120
121
122
123
124
125
126
127
128
129
130
131
132
133
134
135
136
137
138
139
140
141
142
143
144
145
146
147
148
149
150
151
152
153
154
155
156
157
158
159
 
// 47_NumberAppearMoreThanHalf.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <iostream>
using namespace std;

bool g_bValid = true;

// swap a and b
void myswap(int &a, int &b)
{
    int t = a;
    a = b;
    b = t;
}

// use Partition of QuickSort to get Kmin
int Partition(int a[], int left, int right) 
{// partition so that a[left..p-1]<a[p] and a[p+1..right]>=a[p]
    int pivot = a[left], i = left , j = right;
    while (i < j) 
    { //  i from left, j from right
        while (a[i] <= pivot ) i++;
        while (a[j] > pivot ) j--;
        if (i < j) 
            myswap(a[i],a[j]);
    }
    myswap(a[left],a[j]);
    return j;
}

// check whether array is valid
bool IsArrayValid(int a[],int n)
{
    g_bValid = true;
    )
    {
        g_bValid = false;
    }
    return g_bValid;
}

// check whether result appears more than half
bool IsAppearMoreThanHalf(int a[],int n,int result)
{
    ;
    ;i<n;++i)
        if (a[i]==result)
            times++;

bool bIsMoreThanHalf = true;
    *times<=n)
    {
        g_bValid = false;
        bIsMoreThanHalf = false;
    }

return bIsMoreThanHalf;
}

// get number which appears more than half of array
int NumberAppearMoreThanHalf_Solution1(int a[],int n)
{// O(n)
    // whether array is valid
    if (!IsArrayValid(a,n))
        ;

;
    ;
    ;
    int pivot = Partition(a,left,right);
    while(pivot!=middle)
    {
        if (pivot<middle)
        {
            left = pivot+;
            pivot =Partition(a,left,right);
        }
        else
        {
            right = pivot-;
            pivot =Partition(a,left,right);
        }
    }
    // pivot == middle
    int result = a[middle];

// check whether result appears more than half
    if (!IsAppearMoreThanHalf(a,n,result))
        ;

return result;
}

// get number which appears more than half of array
int NumberAppearMoreThanHalf_Solution2(int a[],int n)
{// O(n)
    // whether array is valid
    if (!IsArrayValid(a,n))
        ;

];
    ;
    ;i<n;++i)
    {
        if (a[i]==result)
            appearTimes++;
        else
            appearTimes--;

)
        {
            result = a[i];
            appearTimes = ;
        }
    }

// check whether result appears more than half
    if (!IsAppearMoreThanHalf(a,n,result))
        ;

return result;
}

void test_base(int a[],int n)
{
    int result = NumberAppearMoreThanHalf_Solution2(a,n);
    if (g_bValid)
        cout<<result<<endl;
    else
        cout<<"Invalid array."<<endl;
}

void test_case1()
{
    };
    int n = sizeof(a)/sizeof(int);
    test_base(a,n); // 2
}

void test_case2()
{
    };
    int n = sizeof(a)/sizeof(int);
    test_base(a,n); // invalid array
}

void test_main()
{
    test_case1();
    test_case2();
}

int _tmain(int argc, _TCHAR* argv[])
{
    test_main();
    ;
}

【思路五】:数组中有个数字出现的次数超过了数组长度的一半。也就是说,有个数字出现的次数比其他所有数字出现次数的和还要多。因此我们可以考虑在遍历数组的时候保存两个值:一个是数组中的一个数字,一个是其对应的出现次数。当我们遍历到下一个数字的时候,如果下一个数字和我们之前保存的数字相同,则次数加1。如果下一个数字和我们之前保存的数字不同,则次数减1。如果次数为零,我们需要保存下一个数字,并把次数设为1。这样最后剩下的数字肯定就是出现次数超过数组长度一半的数字。

时间复杂度:O(n);空间复杂度:O(1)。

相比【思路四】不会修改输入数组。

具体代码如下:

 C++ Code 
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
 
// get number which appears more than half of array
int NumberAppearMoreThanHalf_Solution2(int a[],int n)
{// O(n)
    // whether array is valid
    if (!IsArrayValid(a,n))
        ;

];
    ;
    ;i<n;++i)
    {
        if (a[i]==result)
            appearTimes++;
        else
            appearTimes--;

)
        {
            result = a[i];
            appearTimes = ;
        }
    }

// check whether result appears more than half
    if (!IsAppearMoreThanHalf(a,n,result))
        ;

return result;
}

 【参考】

http://zhedahht.blog.163.com/blog/static/25411174201085114733349/

http://www.cnblogs.com/python27/archive/2011/12/15/2289534.html

47. 数组中出现次数超过一半的数字[Number appears more than half times]的更多相关文章

  1. 九度OJ 1370 数组中出现次数超过一半的数字

    题目地址:http://ac.jobdu.com/problem.php?pid=1370 题目描述: 数组中有一个数字出现的次数超过数组长度的一半,请找出这个数字.例如输入一个长度为9的数组{1,2 ...

  2. 数组中出现次数超过一半的数字 -java

    数组中出现次数超过一半的数字 -java 方法一: 数组排序,然后中间值肯定是要查找的值. 排序最小的时间复杂度(快速排序)O(NlogN),加上遍历. 方法二: 使用散列表的方式,也就是统计每个数组 ...

  3. 【C语言】统计数组中出现次数超过一半的数字

    //统计数组中出现次数超过一半的数字 #include <stdio.h> int Find(int *arr, int len) { int num = 0; //当前数字 int ti ...

  4. Leetcode - 剑指offer 面试题29:数组中出现次数超过一半的数字及其变形(腾讯2015秋招 编程题4)

    剑指offer 面试题29:数组中出现次数超过一半的数字 提交网址: http://www.nowcoder.com/practice/e8a1b01a2df14cb2b228b30ee6a92163 ...

  5. 《剑指offer》— JavaScript(28)数组中出现次数超过一半的数字

    数组中出现次数超过一半的数字 题目描述 数组中有一个数字出现的次数超过数组长度的一半,请找出这个数字.例如输入一个长度为9的数组{1,2,3,2,2,2,5,4,2}.由于数字2在数组中出现了5次,超 ...

  6. 《剑指offer》第三十九题(数组中出现次数超过一半的数字)

    // 面试题39:数组中出现次数超过一半的数字 // 题目:数组中有一个数字出现的次数超过数组长度的一半,请找出这个数字.例 // 如输入一个长度为9的数组{1, 2, 3, 2, 2, 2, 5, ...

  7. 剑指Offer - 九度1370 - 数组中出现次数超过一半的数字

    剑指Offer - 九度1370 - 数组中出现次数超过一半的数字2013-11-23 03:55 题目描述: 数组中有一个数字出现的次数超过数组长度的一半,请找出这个数字.例如输入一个长度为9的数组 ...

  8. 剑指Offer:数组中出现次数超过一半的数字【39】

    剑指Offer:数组中出现次数超过一半的数字[39] 题目描述 数组中有一个数字出现的次数超过数组长度的一半,请找出这个数字.例如,输入一个长度为9的数组{1,2,3,2,2,2,5,4,2}.由于这 ...

  9. 编程算法 - 数组中出现次数超过一半的数字 代码(C)

    数组中出现次数超过一半的数字 代码(C) 本文地址: http://blog.csdn.net/caroline_wendy 题目: 数组中有一个数字出现的次数超过数组长度的一半, 请找出这个数字. ...

随机推荐

  1. 自动化测试UI Test, Performance Test, Load Test 总结整理

    MSDN: 测试应用程序,Test apps early and often ,Improve Code Quality 推荐书: <Visual Studio 2015高级编程> < ...

  2. knockout_主页的demo复习

    <!doctype html> <html> <head> <meta charset="utf-8"> <title> ...

  3. onclik的使用.

    //好笨啊,这个居然忘记了,在行间家onclick事件要加();,addEventListener只要使用函数名字就好了 <!doctype html> <html> < ...

  4. python 学习笔记2(list/directory/文件对象/模块/参数传递)

    ### Python的强大很大一部分原因在于,它提供有很多已经写好的,可以现成用的对象. 11. list list是一个类.每个列表都属于该类. >>>nl = [1,2,5,3, ...

  5. 表单form action的url写法

    在写web页面时,标签 是很常见的元素,它的一个属性是action,用来标识将表单交给谁去处理.很显然,这里有一个地址的问题,而且是在服务器这边的地址.比如服务器内的一个servlet.   那么这个 ...

  6. JSP表单处理

    当需要通过从浏览器获取一些信息,在许多情况下,最终给到Web服务器后台程序.浏览器使用两种方法将这些信息传递给Web服务器.这些方法是GET方法和POST方法. GET 方法: GET方法将追加到页面 ...

  7. 在使用easyui,datagrid时,JSON中的如果含有换行符,则不能显示数据

    http://www.xuebuyuan.com/2103538.html 每项值需处理换行符 item = item.Replace("\r\n", ""); ...

  8. hdu 2018 母牛的故事

    #include<stdio.h> int main(void) { int i,n,j,k; long long narr[60]; narr[1]=1; narr[2]=2; narr ...

  9. 取消chrome浏览器下input和textarea的默认样式

    最近一个细节引起了我的注意,chrome浏览器下的input和textarea在聚焦的时候都有一个黄色的边框,而且textarea还可以任意拖动放大,这是不能容忍的,影响美观不说,有时候拖动texta ...

  10. mysql delete删除记录数据库空间不减少问题解决方法

    记得在中学时学计算机时老师就告诉我delete删除记录只是给数据库中的记录加一个删除标识了,这样数据库空间并不是减少了,当时没想这么多,昨天发现一个数据库利用delete 删除之后容量没变,后来百度了 ...